//---------------------------------------------------------------------------
//    $Id: app_shop.h 1348 2013-08-16 00:45:07Z secanell $
//
//    Copyright (C) 2006, 2007, 2008, 2009 by Guido Kanschat
//
//    This file is subject to QPL and may not be  distributed
//    without copyright and license information. Please refer
//    to the file deal.II/doc/license.html for the  text  and
//    further information on this license.
//
//---------------------------------------------------------------------------

#ifndef __appshop__app_shop_h
#define __appshop__app_shop_h

#include <fe/fe_values.h>

namespace dealii
{
  template <int,int, typename number> class Tensor;
  template <class> class VectorSlice;
  template <typename number> class Vector;
  template <typename number> class BlockVector;
  template <typename number> class FullMatrix;
}

using namespace dealii;

#include <vector>


/**
 * \file
 *
 * \brief Definition and documentation of the namespace AppShop.
 */

/**
 * \brief Integration routines for matrices and residual for standard applications.
 */
namespace AppShop
{
				   /**
				    * An auxiliary function computing
				    * the size of a symmetric tensor
				    * in dimension dim.
				    */
  inline unsigned int symm_dim(unsigned int dim)
  {
    return (dim*(dim+1))/2;
  }
  
/**
 * \brief Local integration routines for matrices.
 */
  namespace Matrix
  {
/**
 * \brief Integration of cell matrices.
 */
    namespace Cell
    {
    }
/**
 * \brief Integration of boundary face matrices.
 */
    namespace Boundary
    {
    }
/**
 * \brief Integration of interior face matrices.
 */
    namespace Face
    {
    }
  }
/**
 * \brief Local integration routines for residuals.
 */
  namespace Residual
  {
/**
 * \brief Integration of cell residuals.
 */
    namespace Cell
    {
    }
/**
 * \brief Integration of boundary face residuals.
 */
    namespace Boundary
    {
    }
/**
 * \brief Integration of interior face residuals.
 */
    namespace Face
    {
    }
  }
}

#endif
