//---------------------------------------------------------------------------
//    $Id: main.cc 1348 2013-08-16 00:45:07Z secanell $
//
//    Copyright (C) 2006, 2007 by Guido Kanschat
//
//    This file is subject to QPL and may not be  distributed
//    without copyright and license information. Please refer
//    to the file deal.II/doc/license.html for the  text  and
//    further information on this license.
//
//---------------------------------------------------------------------------

#include <base/logstream.h>
#include <base/parameter_handler.h>
#include <lac/block_vector.h>

#include <appframe/base.h>

#include <fstream>

using namespace AppFrame;

int
main(int argc, char** argv)
{
  AppFrame::initialize(argc, argv);
  AppFrame::open_logfile();
  deallog << "Program:" << argv[0] << std::endl;
  
				   // Initialize parameter handler
  ParameterHandler param;

				   // Initialize
				   // application. Constructor will
				   // declare additional parameters.
  deallog << "Application:";
  MyApp app;
  deallog << std::endl;

  app.declare_parameters(param);
  read_parameter_files(param);
  app.initialize(param);
  
				   // Run the program
  FEVector u;
  FEVEctors dummy;
  
  try
    {
      app->solve(u, dummy);
    }
  catch (const std::exception& e)
    {
      deallog << e.what() << std::endl;
    }
}

