//---------------------------------------------------------------------------
//    $Id: fevectors.cc 1348 2013-08-16 00:45:07Z secanell $
//
//    Copyright (C) 2006, 2007, 2008 by Guido Kanschat
//
//    This file is subject to QPL and may not be  distributed
//    without copyright and license information. Please refer
//    to the file deal.II/doc/license.html for the  text  and
//    further information on this license.
//
//---------------------------------------------------------------------------

#include <appframe/base.h>
#include <lac/block_vector.h>

using namespace AppFrame;

void test (FEVectors& v)
{
  deallog << "scalars: " << v.n_scalars() << std::endl;
  for (unsigned int i=0;i<v.n_scalars();++i)
    {
      unsigned int j = v.find_scalar(v.scalar_name(i));
      deallog << "scalar " << j << " : " << v.scalar_name(i) << " = " << v.scalar(i) << std::endl;
    }
  deallog << "invalid " << v.find_scalar("nonsense") << std::endl;
}


int main()
{
  FEVectors v;
  double a = 1., b=2., c=3., d=4.;

  v.add_scalar(a, "a");
  v.add_scalar(b, "b");
  v.add_scalar(c, "c");

  FEVectors w;

  w.add_scalar(d, "d");
  w.merge(v);
  
  test(v);
  test(w); 
}
