/**
 * A unit test class that tests the fcst_units class. 
 * 
 */



#ifndef _FCST_AgglomerateCLLayer_TESTSUITE
#define _FCST_AgglomerateCLLayer_TESTSUITE

#include <cpptest.h>
#include <boost/lexical_cast.hpp>
#include <string.h>
#include <agglomerate_CL.h>
#include <tafel_kinetics.h>



class AgglomerateCLTest: public Test::Suite
{
public:
    AgglomerateCLTest()
    {
	   //Add a number of tests that will be called during Test::Suite.run()
	   //Generic cases
        TEST_ADD(AgglomerateCLTest::testSetSolution);

    }
protected:
    virtual void setup() ; // setup resources... called before Test::Suite.run() ..not implemented for this test suite
    virtual void tear_down() {} // remove resources...called after Test::Suite.run()  ..not implemented for this test suite
    
private:
    
    boost::shared_ptr< FuelCellShop::Layer::CatalystLayer<dim> > layer; //A child of Base Layer
    
    FuelCellShop::Kinetics::TafelKinetics kinetics;
    std::vector<double> xO2_dummy;

    boost::shared_ptr< FuelCellShop::Material::PolymerElectrolyteBase > electrolyte;
    boost::shared_ptr< FuelCellShop::Material::CatalystBase > catalyst;
    boost::shared_ptr< FuelCellShop::Material::CatalystSupportBase > cat_support;
    
    void testSetSolution();
    
    /** Parameter file */ 
    ParameterHandler param;

};

#endif
