/**
 * A unit test class that tests the fcst_units class. 
 * 
 */



#ifndef _FCST_AnalyticalAgglomerate_TESTSUITE
#define _FCST_AnalyticalAgglomerate_TESTSUITE

#include <map>
#include <base_layer.h>
#include <cpptest.h>
#include <boost/lexical_cast.hpp>
#include <string>
#include <catalyst_layer.h>
#include <tafel_kinetics.h>
#include <agglomerate_ionomer_sun.h>
#include <operating_conditions.h>
#include "boost/shared_ptr.hpp"
#include <chrono>
#include <fcst_utilities.h>

class AnalyticalAgglomerateTest: public Test::Suite
{
public:
	AnalyticalAgglomerateTest()
    {
	   //Add a number of tests that will be called during Test::Suite.run()
	   //Generic cases
        TEST_ADD(AnalyticalAgglomerateTest::testAV);
        TEST_ADD(AnalyticalAgglomerateTest::testAVSetup);
        TEST_ADD(AnalyticalAgglomerateTest::testSetSolution);
        TEST_ADD(AnalyticalAgglomerateTest::testO2CurrentDensity);
        TEST_ADD(AnalyticalAgglomerateTest::test02CurrentDerivative);

    }
protected:
    virtual void setup() {} // setup resources... called before Test::Suite.run() ..not implemented for this test suite
    virtual void tear_down() {} // remove resources...called after Test::Suite.run()  ..not implemented for this test suite
private:
    FuelCellShop::MicroScale::IonomerAgglomerateSun agg;

    void testAVSetup();     //These functions really test the agglomerate base
    void testAV();          //These functions really test the agglomerate base
    void testSetSolution();
    void testO2CurrentDensity();
    void test02CurrentDerivative();



    FuelCell::OperatingConditions OC;
    boost::shared_ptr<FuelCellShop::Layer::CatalystLayer<dim> > CCL;
};

#endif
