/**
 * A unit test class that tests the FCSTdatabase class.
 *
 */



#ifndef _FCST_SolutionVariableTest_TESTSUITE
#define _FCST_SolutionVariableTest_TESTSUITE

#include <cpptest.h>
#include <fcst_db.h>
#include <fcst_utilities.h>
#include <stdexcept>
#include <base_layer.h>

class SolutionVariableTest: public Test::Suite
{
    public:
    SolutionVariableTest()
    {
        //Add a number of tests that will be called during Test::Suite.run()
        //Generic cases
        TEST_ADD(SolutionVariableTest::testAtOperator);
        TEST_ADD(SolutionVariableTest::testName);
        TEST_ADD(SolutionVariableTest::testSize);


    }
    protected:
        virtual void setup(); // setup resources using SolutionVariables 3 different constructors
        virtual void tear_down() {} // remove resources...called after Test::Suite.run()  ..not implemented for this test suite
    private:
        std::vector< FuelCellShop::SolutionVariable> sols;
        std::vector<double> xO2_dummy;

        void testAtOperator();
        void testName();
        void testSize();

};

#endif
