#include "platinum_test.h"

/**
 * Setup is called before any of the tests are called.
 */
void
PlatinumTest::setup()
{
    
    
    FuelCellShop::Material::CatalystBase::declare_Catalyst_parameters(param);    
   
    catalyst = FuelCellShop::Material::CatalystBase::create_Catalyst(param, "Platinum");    
    
    
}

void
PlatinumTest::tear_down() 
{
    //delete catalyst;
}



void
PlatinumTest::testSetSolution()
{
        
    //TEST_ASSERT_MSG(false, "Test not yet implemented!")
}


void
PlatinumTest::testAlphaAnodic()
{
    //We are testing the behaviour of Calculator::add(double a, double b)
    double answer(0);
    double expectedAnswer = 0.5;
    catalyst->set_reaction_kinetics("HOR");
    catalyst->alpha_anodic (answer);  
    
    std::ostringstream streamOut;
    streamOut <<"The value of the alpha_anodic is: "<<answer<<". The expected value is: "<<expectedAnswer<<std::endl;
    streamOut <<"testAlphaAnodic failed!"<<std::endl;

    TEST_ASSERT_MSG(expectedAnswer == answer, streamOut.str().c_str());
    
}

void
PlatinumTest::testReferenceConcentration()
{
    catalyst->set_reaction_kinetics("ORR");
    
    std::vector<VariableNames > reactants;
    reactants.push_back(oxygen_concentration);
    
    std::map< VariableNames, double > answer;
    catalyst->reference_concentration (reactants, answer);

    std::vector<double> expectedAnswer;
    expectedAnswer.push_back(1.6e-05);
   
    std::ostringstream streamOut;
    streamOut <<"The value of the reference_concentration is: "<< answer[oxygen_concentration] <<". The expected value is: "<< expectedAnswer[0]<<std::endl;
    streamOut <<"testReferenceConcentration failed!"<<std::endl;

    TEST_ASSERT_DELTA_MSG(expectedAnswer[0], answer[oxygen_concentration], 1e-06, streamOut.str().c_str());
    
}
