#! /usr/bin/env python
# -*- coding: utf-8 -*-
# Author: CEF PNM Team
# License: TBD
# Copyright (c) 2012

#from __future__ import print_function

"""
module baseclass: contains OpenPNM base classes
===============================================

.. warning:: The classes of this module should be loaded through the 'MISC.__init__.py' file.

Examples:
---------
>>> import OpenPNM 
>>> tmp=PNM.misc.testinheritance()

"""


import logging as _logging

# set up logging to file - see previous section for more details
_logging.basicConfig(level=_logging.DEBUG,
                    format='%(asctime)s %(name)-12s %(levelname)-8s %(message)s',
                    datefmt='%m-%d %H:%M',
                    )


class lobject(object):
    r"""
    lobject: Base class for OpenPNM
    
    
    Base class with a few bells and whistles. Mainly output on screen, logging
    and pickling. This is the class from which all other classes should inherit.
    
    Attributes
    ----------
    
    self._logger : _logging.logger
       This class defines a logger for the class and all classes inheriting from it.
       it supports all settings of the standard logger. It still needs some fine 
       tuning.
    
    
    
    
    """
    def __init__(self):
        super(lobject,self).__init__()
        self._logger = _logging.getLogger(self.__class__.__name__)
    
    def IOpickle(self,filename="test.pickle"):
        r"""
        Write the class object to a pickle file.close
        
        Parameters
        ---------- 
        filename : string
            name of the file to be written.
        """
        self._logger.debug('Pickle self')
    def IOunpickle(self):
        self._logger.debug('UnPickle self')
        
class testinheritance(lobject):
    r"""
    testinheritance: Trial inheritance from lobject.
    """
    def __init__(self):
        super(testinheritance,self).__init__()
        self._logger.debug("Hallo")