# Author: Andreas Putz
# Copyright (c) 2013, OpenPNM
# License: TBD.
r"""
PythonFCST: A scientific pore network calculator for porous transport media
===========================================================================

Documentation is available in the docstrings and in ths sphinx documentation.

Contents
--------
The PythonFCST package imports all the functions from the top level modules.

Subpackages
-----------

.. list-table:: `PythonFCST` module structure.
   :widths: 10 80 10
   :header-rows: 1

   * - name
     - description
     - autoload
   * - `BASE`
     - common utilities and classes used by most of the othe rmodules
     - yes
   * - `MESH`
     - Mesh generation classes
     - yes
   * - `VISU`
     - Visualisation methods
     - yes
   * - `interactive/`
     - setup of IPython-based shell `isfepy`
     -
 
Prefix convention
-----------------
::

  None as yet
 
 
Utility tools
-------------
::

 TODO                --- Todo
 
 
Import
------
>>> import PythonFCST as fcst

Inheritance diagram
-------------------
    
.. inheritance-diagram:: PythonFCST
"""

__version__ = '0.0.1'

__requires__ = [
    'scipy',
    'numpy',
]

__extras_require__ = {
    'app': [
        'envisage',
    ],
}

# __all__ = ['misc']






import BASE

#
# from PNMbase import *
# from PNMalgorithms import *
# from PNMgenerators import *
# from PNMIO import *
# from PNMparameters import *
# from PNMtransport import *



