#!/bin/bash

cd ../data/mea/testing_agglomerate

../../../bin/fuel_cell-2d.bin main_app_pemfc_test.prm

if [ "${PIPESTATUS[0]}" != "0" ]; then
	echo  2>&1 | tee --append ../../../tests_summary.log
	echo  "Results summary from the app_pemfc agglomerate test:" 2>&1 | tee --append ../../../tests_summary.log
	echo 2>&1 | tee --append ../../../tests_summary.log
	echo "-------------------------------------------------------------------------------" 2>&1 | tee --append tests_summary.log
	echo "The simulation did not run correctly. Please review the tests_output.log file  "  2>&1 | tee tests_summary.log
	echo "-------------------------------------------------------------------------------" 2>&1 | tee --append tests_summary.log
	echo 2>&1 | tee --append ../../../tests_summary.log
  exit 2
else
	../../../test/test_comparison.py dakota_tabular.dat test_results.dat
	if [ "${PIPESTATUS[0]}" != "0" ]; then
		echo  2>&1 | tee --append ../../../tests_summary.log
		echo  "Results summary from the app_pemfc agglomerate test:" 2>&1 | tee --append ../../../tests_summary.log
		echo 2>&1 | tee --append ../../../tests_summary.log
		echo "-------------------------------------------------------------------------------" 2>&1 | tee --append ../../../tests_summary.log
		echo "Results from the test do not match expected results" 2>&1 | tee --append ../../../tests_summary.log
		echo "Please check the results in dakota_tabular.dat against that of test_results.dat" 2>&1 | tee --append ../../../tests_summary.log
		echo "-------------------------------------------------------------------------------" 2>&1 | tee --append ../../../tests_summary.log
		echo 2>&1 | tee --append ../../../tests_summary.log
		exit 2
	else 
		echo  2>&1 | tee --append ../../../tests_summary.log
		echo  "Results summary from the app_pemfc agglomerate test:" 2>&1 | tee --append ../../../tests_summary.log
		echo 2>&1 | tee --append ../../../tests_summary.log
		echo "--------------------------------------------" 2>&1 | tee --append ../../../tests_summary.log
		echo "Results from the test match expected results" 2>&1 | tee --append ../../../tests_summary.log
		echo  "--------------------------------------------" 2>&1 | tee --append ../../../tests_summary.log
		echo 2>&1 | tee --append ../../../tests_summary.log
		exit 0
	fi
fi

